/* zlist table */

#include <stdio.h>
#include <ctype.h>
#include "epelle.h"

#define MAXLENGTH 256                   /* longueur maxi des mots */
#define CTOI(a) ((a<0) ? a+256 : a)

typedef struct NOEUD {
    char c,existe;
    unsigned int fils,frere;
} noeud;

noeud T[MAX_NODES];
int racine;
char mot[MAXLENGTH];

main(argc,argv)
int argc;
char* argv[];
{
    FILE *f,*fopen();
    char c,c1,c2;
    int i=0;

    /* entre'e de la table */
#ifndef MSDOS
    f = fopen(argv[1],"r");
#else
    f = fopen(argv[1],"rb");
#endif
    while ((c = getc(f)) != (char)EOF) {
	T[++i].c = c;
	c =  getc(f);
	T[i].existe = I(c) & 0x1;
	c1 = getc(f); c2 = getc(f);
	T[i].fils = CTOI(c1) + (CTOI(c2) << 8);
	c1 = getc(f); c2 = getc(f);
	T[i].frere = CTOI(c1) + (CTOI(c2) << 8);
	T[i].fils += (I(c) & 0xE) << 15;
	T[i].frere += (I(c) & 0x70) << 12;
    }
    racine = i;

    /* boucle d'affichage */
    affiche_tout(racine,0);
}

affiche_tout(node,i)
int node,i;
{
    mot[i] = T[node].c;
    if (T[node].existe) affiche_mot(i);
    if (T[node].fils) affiche_tout(T[node].fils,i+1);
    if (T[node].frere) affiche_tout(T[node].frere,i);
}

affiche_mot(i)
int i;
{
    int j;
    for (j=1;j<=i;j++) putchar(mot[j]);
    putchar('\n');
}
